// CivilTools.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "\Program Files (x86)\BabaCAD\BabaCAD\API\Inc\BabaCADExtensions.h"
#include "CivilTools.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//
//TODO: If this DLL is dynamically linked against the MFC DLLs,
//		any functions exported from this DLL which call into
//		MFC must have the AFX_MANAGE_STATE macro added at the
//		very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

// CCivilToolsApp

BEGIN_MESSAGE_MAP(CCivilToolsApp, CWinApp)
END_MESSAGE_MAP()

static TBBUTTON tbButtons[2] = 
{{0, ID_SLOPE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, NULL},
{1, ID_SLOPESET, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, NULL}};

const TCHAR *extName = L"CivilTools.bem";
HINSTANCE m_hInstDLL;

struct SlopeType
{
	double distance;
	double longPart;
	double shortPart;
};

SlopeType m_SlopeData;
long m_objid;
bool tikataka;

BOOL BabaCADExtEntryPoint(TCHAR &defaultCmdSymbol, TCHAR &getVarSymbol)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	AddCommand(_T("Slope"),L"",_T("Terrain slope lines"),_T("CivilTools.bem"), m_hInstDLL, ID_SLOPE);
	AddCommand(_T("SlopeSet"),L"",_T("Configure slope lines"),_T("CivilTools.bem"),m_hInstDLL ,ID_SLOPESET);
	AddCommand(_T("CivilTools"),L"",_T("Civil Tools"),_T("CivilTools.bem"),m_hInstDLL);

	m_SlopeData.distance = 2.0;
	m_SlopeData.longPart = 0.9;
	m_SlopeData.shortPart = 0.45;

	tikataka = false;

	return TRUE;
}

BOOL Slope(int &CmdSeq)
{
	//DisplayMsg(_T("Testing SLOPE cmd...!"));

	if (CmdSeq==1)
	{
		SetUserInputMode(4, false, 0, 0);
		DisplayPromptMsg(L"Select slope polyline: ");
		CmdSeq++;
		return TRUE;
	}

	if (CmdSeq==2)
	{
		int ssid=0;
		addSelectionSet(ssid);
		addSelectedToSelectionSet(ssid);

		m_objid=-1;
		getObjFromSelectionSet(m_objid, 0, ssid);

		releaseSelectionSet(ssid);
		SetUserInputMode(4, false, 0, 0);
		DisplayPromptMsg(L"Select second polyline: ");
		CmdSeq++;
		return TRUE;
	}

	
	int ssid2=0;
	addSelectionSet(ssid2);
	addSelectedToSelectionSet(ssid2);
	

	long objid2=-1;
	getObjFromSelectionSet(objid2, 0, ssid2);

	releaseSelectionSet(ssid2);

	long objid1=m_objid;

	/*
	TCHAR tbuf[50];
	wsprintf(tbuf, L"ObjId1 = %d",objid1);
	DisplayMsg(tbuf);

	wsprintf(tbuf, L"ObjId2 = %d",objid2);
	DisplayMsg(tbuf);
	*/

	TCHAR tbuf[200];

  if (objid1>0 && objid2>0)
	{
		//int ss2=0;
		//addSelectionSet(ss2);
		//DoCommandLine(L"(setq ss1 (ssadd))");

		BcDbObject *BcObj1 = NULL;
		BcDbObject *BcObj2 = NULL;
		bcdbOpenObject(BcObj1,objid1, bcdbOpenMode::kForRead);
		bcdbOpenObject(BcObj2,objid2, bcdbOpenMode::kForRead);

		if (BcObj1==NULL || BcObj2==NULL)
		{
			DisplayMsg(L"Cannot open selected entity!");
			return TRUE;
		}

		if (BcObj1->ObjType==bcEnums::OBT_PLINE && BcObj2->ObjType==bcEnums::OBT_PLINE)
		{
			BcDb2DPolyline *pObj1 = BcDb2DPolyline::cast(BcObj1);
			BcDb2DPolyline *pObj2 = BcDb2DPolyline::cast(BcObj2);

			double rest = 0.0;
			int ort = 1;

			mmPoint op1 = pObj1->ObjPoints.getAt(0);
			mmPoint op2 = pObj1->ObjPoints.getAt(1);

			mmPoint spt = pObj2->ObjPoints.getAt(0);
			mmPoint ept = pObj2->ObjPoints.getAt(pObj2->ObjPoints.count-1);

			Vector3D cv1(spt.x-op1.x,spt.y-op1.y,0);
			Vector3D cv2(ept.x-op1.x,ept.y-op1.y,0);

			Vector3D ortx(op2.x-op1.x,op2.y-op1.y,0);

			if (cv1.length()<cv2.length())
			{
				ortx.cross(ortx,cv1);
				if (ortx.z<0) ort = -1;
			}
			else
			{
				ortx.cross(ortx,cv2);
				if (ortx.z<0) ort = -1;
			}
			

			for (int i=0;i<pObj1->ObjPoints.count-1;i++)
			{
				mmPoint p1 = pObj1->ObjPoints.getAt(i);
				mmPoint p2 = pObj1->ObjPoints.getAt(i+1);

				Vector3D v(p2.x-p1.x,p2.y-p1.y,0);
				double vlen = v.length();
				v = v.normalize();

				Vector3D vn=v*rest;
				mmPoint pt1,pt2;

				if (rest>0.0)
				{				
					pt1.x = p1.x+vn.x;
					pt1.y = p1.y+vn.y;
					Vector3D vo = v*m_SlopeData.distance*0.1;
					pt2.x = pt1.x-vo.y*ort;
					pt2.y = pt1.y+vo.x*ort;
				}
				else
				{
					pt1.x = p1.x;
					pt1.y = p1.y;

					Vector3D vo = v*m_SlopeData.distance*0.1;
					pt2.x = pt1.x-vo.y*ort;
					pt2.y = pt1.y+vo.x*ort;
				}

				BcDbLine *pLine = new BcDbLine();
				pLine->addPoint(pt1);
				pLine->addPoint(pt2);
				extendObjects(pLine,pt2,pObj2);

					mmPoint r1 = pLine->ObjPoints.getAt(0);
					mmPoint r2 = pLine->ObjPoints.getAt(1);
					Vector3D extz(r2.x-r1.x,r2.y-r1.y,0);
					extz = extz*(tikataka?m_SlopeData.longPart:m_SlopeData.shortPart);
					pt2.x = r1.x + extz.x;
					pt2.y = r1.y + extz.y;
					pLine->ObjPoints.updatePoint(1,pt2);

				addLine(pLine);
				tikataka = !tikataka;

				double cuml=rest;

				vn=v*m_SlopeData.distance;

				while (1)
				{
					cuml+=m_SlopeData.distance;
					if (cuml>vlen)
					{
						rest = cuml-vlen;
						break;
					}
	
					mmPoint pn1(pt1.x + vn.x, pt1.y + vn.y);
					Vector3D vo = v*m_SlopeData.distance*0.1;
					mmPoint pn2(pn1.x - vo.y*ort, pn1.y + vo.x*ort);

					pt1.x = pn1.x;
					pt1.y = pn1.y;

					BcDbLine *pLine = new BcDbLine();
					pLine->addPoint(pn1);
					pLine->addPoint(pn2);

					extendObjects(pLine,pn2,pObj2);

					mmPoint r1 = pLine->ObjPoints.getAt(0);
					mmPoint r2 = pLine->ObjPoints.getAt(1);
					Vector3D extz(r2.x-r1.x,r2.y-r1.y,0);
					extz = extz*(tikataka?m_SlopeData.longPart:m_SlopeData.shortPart);
					pn2.x = r1.x + extz.x;
					pn2.y = r1.y + extz.y;
					pLine->ObjPoints.updatePoint(1,pn2);

					addLine(pLine);
					tikataka = !tikataka;
				}
			}//end

		}
		else
		{
			DisplayMsg(L"Error: must select a polyline!");
		}
	}

	return TRUE;

}

BOOL SlopeSet(int &CmdSeq)
{
	TCHAR tbuf[250];

	if (CmdSeq==1)
	{
		swprintf(tbuf,L"Specify distance between lines: <%.2f> ",m_SlopeData.distance);
		DisplayPromptMsg(tbuf);
		CmdSeq++;
		return TRUE;
	}

	if (CmdSeq==2)
	{
		GetInputString(tbuf);

		if (wcscmp(tbuf,L"")!=0)
		{
			m_SlopeData.distance = _wtof(tbuf);
		}

		swprintf(tbuf,L"Specify first slope line ratio: <%.2f> ",m_SlopeData.longPart);
		DisplayPromptMsg(tbuf);
		CmdSeq++;
		return TRUE;
	}

	if (CmdSeq==3)
	{
		GetInputString(tbuf);

		if (wcscmp(tbuf,L"")!=0)
		{
			m_SlopeData.longPart = _wtof(tbuf);
		}

		swprintf(tbuf,L"Specify second slope line ratio: <%.2f> ",m_SlopeData.shortPart);
		DisplayPromptMsg(tbuf);
		CmdSeq++;
		return TRUE;
	}

	GetInputString(tbuf);

	if (wcscmp(tbuf,L"")!=0)
	{
		m_SlopeData.shortPart = _wtof(tbuf);
	}

	return true;
}

BOOL CivilTools(int &CmdSeq)
{	
	CFrameWnd *pFrameWnd = (CFrameWnd*)AfxGetMainWnd(); 

	AFX_MANAGE_STATE(AfxGetStaticModuleState( ));

	CreateExtensionToolbar(IDR_TOOLBAR1, m_hInstDLL, L"Civil Tools",tbButtons,2);
	
	/*
	if (m_someDlg.Create(m_someDlg.IDD, pFrameWnd))
	{
		CreateExtensionDockbar(m_someDlg.IDD, m_hInstDLL, L"Civil Tools",&m_someDlg);
	}*/

	return true;
}


// CCivilToolsApp construction

CCivilToolsApp::CCivilToolsApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CCivilToolsApp object

CCivilToolsApp theApp;


// CCivilToolsApp initialization

BOOL CCivilToolsApp::InitInstance()
{
	CWinApp::InitInstance();

	m_hInstDLL = this->m_hInstance;

	return TRUE;
}


bool getLineToLineIntersection(mmPoint p0, mmPoint p1, mmPoint p2, mmPoint p3, double *i_x, double *i_y)
{
    double s1_x, s1_y, s2_x, s2_y;
    s1_x = p1.x - p0.x;     s1_y = p1.y - p0.y;
    s2_x = p3.x - p2.x;     s2_y = p3.y - p2.y;

    double s, t;
    s = (-s1_y * (p0.x - p2.x) + s1_x * (p0.y - p2.y)) / (-s2_x * s1_y + s1_x * s2_y);
    t = ( s2_x * (p0.y - p2.y) - s2_y * (p0.x - p2.x)) / (-s2_x * s1_y + s1_x * s2_y);

    if (s >= 0 && s <= 1 && t >= 0 && t <= 1)
    {
        // Collision detected
        if (i_x != NULL)
            *i_x = p0.x + (t * s1_x);
        if (i_y != NULL)
            *i_y = p0.y + (t * s1_y);
        return 1;
    }

    return 0; // No collision
}

bool extendLine(BcDbLine *pPoly, BcDb2DPolyline* pEdgeObj, mmPoint selPnt, int &idx, mmPoint &iPt, double &edist)
{
	mmPoint p1,p2,p3,p4;
	int isel = 9999999;
	double mindist = 9999999.0;
	double relfac=0.0;
	double edist2=0.0;
	double dist = 0.0;
	int i=-1;

	vector<mmPoint> tmpPnts = pPoly->ObjPoints.pntArr;

				p1 = tmpPnts[1];
				p2 = tmpPnts[0];
				i = 0;

			vector<mmPoint> tmpPnts2 = pEdgeObj->ObjPoints.pntArr;

			Vector3D extv;

			for (int j=0;j<tmpPnts2.size()-1;j++)
			{
				p3 = tmpPnts2[j];
				p4 = tmpPnts2[j+1];

				mmPoint pt1 = p1;
				mmPoint pt2 = p2;

				extv = Vector3D(pt1.x-pt2.x,pt1.y-pt2.y,0.0)*99.0;
				pt2 = pt1;
				pt1 = mmPoint(extv.x+pt2.x,extv.y+pt2.y);

				mmPoint iPtT;
				int ind = getLineToLineIntersection(pt1,pt2,p3,p4,&iPtT.x,&iPtT.y);					
				edist2 = Vector3D(iPtT.x-p1.x,iPtT.y-p1.y,0).length();

				if (ind>0 && edist2<edist)
				{
					edist = edist2;
					idx = i;
					iPt = iPtT;
				}
			}//end for j

	return (idx>-1);
}

bool extendObjects(BcDbLine* pExtendObj, mmPoint selPnt, BcDb2DPolyline *pObj)
{
	mmPoint pt1, pt2, pt3, pt4, iPt;
	int idx = -1;
	double edist=99999999.0;

	bool ret = false;

	ret = extendLine(pExtendObj,pObj,selPnt,idx,iPt,edist);

	if (idx>-1)
	{
		pExtendObj->ObjPoints.updatePoint(1, iPt);
	}

	return ret;
}
